"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useFetchTokens = void 0;
const react_1 = require("react");
const react_redux_1 = require("react-redux");
const wouter_1 = require("wouter");
const slice_1 = require("@procyon/auth/slice");
const actions_1 = require("../actions");
const useFetchTokens = ({ baseUrl, clientId, tokenEndpoint, redirectUri }) => {
    const dispatch = (0, react_redux_1.useDispatch)();
    const [, setLocation] = (0, wouter_1.useLocation)();
    return (0, react_1.useCallback)((code) => __awaiter(void 0, void 0, void 0, function* () {
        const { data: tokens } = yield (0, actions_1.fetchTokens)({
            baseUrl,
            tokenEndpoint,
            clientId,
            redirectUri: redirectUri,
            grantType: 'authorization_code',
            code,
        });
        if (tokens) {
            dispatch((0, slice_1.setAuthTokens)({
                accessToken: tokens.access_token,
                refreshToken: tokens.refresh_token,
                idToken: tokens.id_token,
                accessExpiresIn: tokens.expires_in,
                refreshExpiresIn: tokens.refresh_expires_in,
                sessionState: tokens.session_state,
            }));
            setLocation('/');
        }
    }), []);
};
exports.useFetchTokens = useFetchTokens;
